<?php
/**
 * Common use functions - sql
 * @author José Carlos Cruz Parra AKA internia
 * josecarlos@programadorphpfreelance.com
 * http://programadorphpfreelance.com
 * 2008-2017
 * This code is released under the GNU General Public License.
 */


/**
 * @return string
 * @param array $data
 * @param string $table
 * @param bool $onDuplicateKeyUpdate
 */
function buildQuery_Insert($data, $table, $onDuplicateKeyUpdate=false)
{
	$query = "INSERT INTO `".$table."`(";
	$keys = array_keys($data);
	for($c=0,$size=sizeof($data); $c<$size; $c++)
	{
        if(is_array($data[$keys[$c]]) || is_object($data[$keys[$c]]))
        {
            $data[$keys[$c]] = serialize($data[$keys[$c]]);
        }

		if($c > 0)
		{
			$query .= ', ';
		}
		$query .= "`".$keys[$c]."`";
	}
	$query .= ") VALUES(";
	for($c=0; $c<$size; $c++)
	{
		if($c > 0)
		{
			$query .= ', ';
		}
        $query .= sprintf("'%s'", addcslashes($data[$keys[$c]], "\\'"));
	}

	$query .= ")";

	if($onDuplicateKeyUpdate)
	{
		$query .= " ON DUPLICATE KEY UPDATE ";
		$keys = array_keys($data);
		for($c=0,$size; $c<$size; $c++)
		{
			if($c > 0)
			{
				$query .= ", ";
			}
            $query .= sprintf("`%s` = '%s'", $keys[$c], addcslashes($data[$keys[$c]], "\\'"));
		}
	}

	return $query.';';
}
/**
 * @return string
 * @param array $data
 * @param string $table
 * @param ids array o $string
 * @param bool $devolverVacio
 */
function buildQuery_Update($data, $table, $ids=null, $devolverVacio=false)
{
	$query = "UPDATE `".$table."` SET ";
	$keys = array_keys($data);
	for($c=0,$size=sizeof($data); $c<$size; $c++)
	{
        if(is_array($data[$keys[$c]]) || is_object($data[$keys[$c]]))
        {
            $data[$keys[$c]] = serialize($data[$keys[$c]]);
        }

		if($c > 0)
		{
			$query .= ', ';
		}
		$query .= sprintf("`%s` = '%s'", $keys[$c], addcslashes($data[$keys[$c]], "\\'"));
	}

	return $query.DB_Connection::ids2where($ids, $devolverVacio).";";
}
/**
 * @return string
 * @param string $table
 * @param array $ids
 */
function buildQuery_Delete($table, $ids=null)
{
	return "DELETE FROM `".$table."`".DB_Connection::ids2where($ids).";";
}
/**
 * Une una condición where y un filtro que puede contener where, order by,...
 *
 * @param string $where
 * @param string $filtro
 * @return string
 */
function mergeWhereFiltro($where='', $filtro='')
{
	$filtro = trim($filtro);
	if($filtro)
	{
		if($where)
		{
			if(strtoupper(substr($filtro, 0, 6)) == 'WHERE ')
			{
				$filtro = $where.' AND ('.substr($filtro, 6).')';
			}
			else
			{
				$filtro = $where.' '.$filtro;
			}
		}
	}
	else
	{
		$filtro = $where;
	}

	return $filtro;
}