<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {link} function plugin
 *
 * Type:     function<br />
 * Name:     link<br />
 * Purpose:  build an html form field<br />
 * @link
 * @author José Carlos Cruz Parra AKA Internia
 * @param array
 * @param Smarty
 */
function smarty_function_html_formfield($params, &$smarty)
{
	if (empty($params['id'])) {
		$params['id'] = mt_rand(100000000, 999999999);
	}
	if (empty($params['info'])) {
		$params['info'] = "tag=input;type=text";
	}

	$items = explode(";", $params["info"]);
	$info = array();
	foreach($items as $item)
	{
		$aux = explode("=", $item);
		$info[$aux[0]] = $aux[1];
	}
	if($params['requerido'])
	{
		if(!isset($info["class"]))
		{
			$info["class"] = "requerido";
		}
		elseif(!ereg("requerido", $info["class"]))
		{
			$info["class"] .= " requerido";
		}
	}

	$name = empty($params["grupo"]) ? $params["id"] : "{$params["grupo"]}[{$params["id"]}]";
	$class = html_formfield_buildKey("class", $info["class"]);
	$valor = is_array($params["valor"]) ? $params["valor"][$params["id"]] : $valor;
	$title = html_formfield_buildKey("title", $params["title"]);

	$html = "";
	switch($info["tag"])
	{
		case "input":
			$html .= sprintf("<input type=\"%s\" %s name=\"%s\" %s",
				$info["type"],
				$class,
				$name,
				$title
				);
			switch($info["type"])
			{
				case "file":
					//break;
				case "text":
					$html .= sprintf("%s %s value=\"%s\"",
						html_formfield_buildKey("size", $info["size"]),
						html_formfield_buildKey("maxlength", $info["maxlength"]),
						$valor
						);
					break;
				case "checkbox":
					if($valor)
					{
						$html .= "checked=\"checked\" ";
					}
					break;
			}
			$html .= "/>";
			if($info["type"] == "text" && ereg("date", $class))
			{
				$html .= " <span class=\"mini\">En formato DD/MM/AAAA</span>";
			}
			break;
		case "select":
			$html .= "<select name=\"{$name}\" {$class} {$title}>
				<option value=\"{$valor}\">{$valor}</option>
				</select>";
			break;
		case "textarea":
			$html .= sprintf("<textarea %s name=\"%s\" %s %s %s>%s</textarea>",
				$class,
				$name,
				html_formfield_buildKey("cols", $info["cols"]),
				html_formfield_buildKey("rows", $info["rows"]),
				$title,
				$valor
				);
			break;
	}

	return $html;
}

function html_formfield_buildKey($key, $value)
{
	return empty($value) ? "" : "{$key}=\"{$value}\"";
}

/* vim: set expandtab: */

?>
