<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty {swphp_linkadmin} function plugin
 *
 * Type:     function<br />
 * Name:     swphp_linkadmin<br />
 * Purpose:  build a link to an admin location<br />
 * @link
 * @author José Carlos Cruz Parra programadorphpfreelance.com
 * @param array
 * @param Smarty
 */
function smarty_function_swphp_linkadmin($params, &$smarty)
{
	$str = '';

    if(isset($params['full']) && $params['full'])
    {
        global $swphp_config;

        $str = $swphp_config['url'];
    }

    $str .= SWPHP_ADMIN_DIR;

	if(isset($params['mod']) && $params['mod'])
	{
		$str .= $params['mod'].'/';
	}

	if(isset($params['sub']) && $params['sub'])
	{
		$str .= $params['sub'].'/';
	}

	if(isset($params['query']) && $params['query'] != '')
	{
		$str .= '?';
		$str .= isset($params['noencode']) && $params['noencode'] ? $params['query'] : str_replace('&', '&amp;', $params['query']);
	}

	return $str;
}

/* vim: set expandtab: */

?>
