<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-13
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/comunini_web.inc.php
 */

//ACCIONES COMUNES AL INICIO DE CADA SCRIPT PARA MOSTRAR EN WEB

//¡¡NO EDITAR!!
//Si quieres añadir acciones al inicio de cada script, hazlo en config/customini.inc.php

require(SWPHP_INC_DIR.'comun.inc.php');

//Redirigir a canónica
if($swphp_config['google']['redirigiracanonica'] && $swphp_config['google']['canonical'])
{
	$aux = str_replace('http://', $_SERVER['HTTPS'] ? 'https://' : 'http://', $swphp_config['google']['canonical']);
	if($aux != quitarBarra($swphp_config['url']))
	{
		header('HTTP/1.1 301 Moved Permanently');
		header('Location: '.$aux.$_SERVER['REQUEST_URI']);
		exit;
	}
}

//SMARTY
define('SMARTY_RESOURCE_CHAR_SET', SWPHP_CHARSET);
require(SWPHP_COMMON_DIR.'smarty/Smarty.class.php');
define('SWPHP_TEMPLATES_DIR', SWPHP_THEME_DIR.'/tpl/');
if(!is_dir(SWPHP_THEME_DIR) || !is_dir(SWPHP_TEMPLATES_DIR))
{
	die("No se encuentra el tema gráfico <b>".SWPHP::_HtmlEntities(SWPHP_THEME)."</b>");
}
$smarty = new Smarty();
$smarty->template_dir = SWPHP_TEMPLATES_DIR;
$smarty->caching = false;
$smarty->force_compile = (isset($swphp_config['smarty']['force_compile']) && $swphp_config['smarty']['force_compile']) || (isset($_GET['force_compile']) && $_GET['force_compile']);
$smarty->compile_check = false;
//SWPHP::_CheckDirWritable('templates_c', true, true);
//Plantilla principal
$swphp_main_template = 'pagina.tpl';

//VERSIÓN
define('SWPHP_VERSION', '1.1.0');
SWPHP::_CheckVersionSWPHP();
$swphp_version = "EA ".SWPHP_VERSION;

//COMPROBACIONES DE SEGURIDAD PARA USUARIOS LOGUEADOS
$hayfalta = false;
if(!empty($_SESSION["user"]["autenticado"]) && empty($_SESSION["user"]["recienautenticado"]))
{
	//Comprobamos si ha caducado la sesión
	if((time() - SWPHP_SESSION_EXPIRE_TIME) > $db->GetValue("time", session_name(), "WHERE id = '".session_id()."'"))
	{
		$hayfalta = true;
		SWPHP::_Msg("Tu sesión de usuario ha caducado", "aviso");
	}

	//Comprobamos si ha rotado la IP
	if(SWPHP_CLIENT_IP != $db->GetValue("ip", session_name(), "WHERE id = '".session_id()."'"))
	{
		$hayfalta = true;
		SWPHP::_Msg("Se ha cerrado tu sesión de usuario por motivos de seguridad", "aviso");
	}
}

if($hayfalta)
{
	SWPHP::_Logout(null, true);
}
else
{
	//PARA LOGUEAR
	include(SWPHP_INC_DIR.'login.inc.php');
}

$_SESSION["user"]["recienautenticado"] = false;

//PARA DISPOSITIVOS MOVILES
if(isset($_GET['mobile']))
{
	$_SESSION['mobile'] = $_GET['mobile'] ? true : false;
}
elseif(!empty($swphp_config['display']['mobile_detect']) && !isset($_SESSION['mobile']))
{
	include(SWPHP_COMMON_DIR.'classes/Mobile_Detect.php');

	$mobile_detect = new Mobile_Detect();

	$_SESSION['mobile'] = $mobile_detect->isMobile();
}

//CARGAR PLUGINS
//TODO: cargar de la base de datos sólo los activados

$dirs = getDirs(SWPHP_PLUGINS_DIR);
foreach($dirs as $dir)
{
	SWPHP::_Include('functions.inc.php', SWPHP_PLUGINS_DIR."{$dir}/");
}

//XAJAX
include('xajax/xajax_core/xajaxAIO.inc.php');
$xajax = new Xajax();
$xajax->setCharEncoding(SWPHP_CHARSET);

//CARGAR CÓDIGO PERSONALIZADO SI EXISTE
if(is_file('config/customini.inc.php'))
{
	include('config/customini.inc.php');
}
