<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2015-10-16
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/banip/admin/index.php
 *
 */

include_once SWPHP_COMMON_DIR.'functions/arrays.php';

$paginador = SWPHP::_CrearPaginador('IPs');
$paginador->SetParam('etiqueta', 'ip');
$paginador->Fill("SELECT b.ip, b.fechayhora, b.fallos, IF(b.permanente, 'Sí', 'No') AS permanente, '' AS controles"
	." FROM ".SWPHP_DBPREFIX."banip AS b"
	." WHERE b.baneada = '1'"
	." ORDER BY b.fechayhora DESC, b.ip DESC");

$paginador->SetParam('campos', array(
	'ip'=>array('label'=>'IP'),
	'fechayhora'=>array('label'=>'Fecha y hora', 'class'=>'center'),
	'fallos'=>array('label'=>'Fallos', 'class'=>'numeric'),
	'permanente'=>array('label'=>'Permanente', 'class'=>'center'),
	'controles'=>array('label'=>'', 'orderby'=>false)
	));

$paginador->SetParam('buscador', array(
	'b.ip'=>'IP',
	'b.fechayhora'=>'Fecha y hora',
	'b.fallos'=>'Fallos',
	'b.permanente'=>'Permanente',
	));

function applyToReg(&$reg, $key)
{
	global $swphp_mod_clave;

	$id = $reg['ip'];

	$reg['controles'] = "<a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/?op=info&amp;id={$id}\">".SWPHP::_Icon("info.png", 16, array("alt"=>"Información", "title"=>"Información IP {$id}"))."</a>"
		." <a id=\"aEliminar".array_ToString(array('ip'=>$id), '_')."\" href=\"javascript:EliminarIP('{$id}')\" title=\"Desbloquear\">".SWPHP::_Icon("remove.png", 16, array("alt"=>"Desbloquear", "title"=>"Desbloquear IP {$id}"))."</a>";
}
$paginador->SetParam('applyToRegs', 'applyToReg');

$admin_template = "{$swphp_module_templates_dir}admin/ips.tpl";

$smarty->assign('paginador', $paginador);
