<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2016-05-09
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/contacto/admin/localizaciones/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de una localización
 *
 * @param array $data
 * @return bool
 */
function contacto_localizaciones_validarDatos($data)
{
	$ok = true;

	$requeridos = array(
		'titulo'=>'Título',
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data[$key]) || $data[$key] == '')
		{
			SWPHP::_Msg('Falta el dato:'." {$nombre}", "error");
			$ok = false;
		}
	}

	//TODO: Validar teléfonos, codigopostal,...

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar una localización en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function contacto_localizaciones_prepararDatos($data, $id=0)
{
	global $db;

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'titulo':
			case 'direccion1':
			case 'direccion2':
			case 'localidad':
			case 'provincia':
			case 'codigopostal':
			case 'telefono':
			case 'fax':
			case 'movil':
			case 'movil2':
			case 'googlemaps':
			case 'horario1':
			case 'horario2':
				$data[$key] = trim($value);
				break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	$ahora = date('Y-m-d H:i:s');
	if($id == 0)
	{
		$data['fechayhoraregistro'] = $ahora;
		$data['user_idregistro'] = $_SESSION['user']['id'];
	}
	$data['fechayhoraultima'] = $ahora;
	$data['user_idultima'] = $_SESSION['user']['id'];

	return $data;
}
