<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-04-11
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/faq/admin/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de pregunta
 *
 * @param array $data
 * @return bool
 */
function faq_validarDatos($data)
{
	global $swphp_idiomas;

	$ok = true;

	$requeridos = array(
		'pregunta'=>'Pregunta',
		'respuesta'=>'Respuesta',
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key]) || $data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key] == '')
		{
			SWPHP::_Msg("Falta el dato: {$nombre} ({$swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['nombre']})", "error");
			$ok = false;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar una pregunta en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function faq_prepararDatos($data, $id=0)
{
	global $db;

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'peso':
				$data[$key] = intval($value);
				break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	$ahora = date('Y-m-d H:i:s');
	if($id == 0)
	{
		$data['fechayhoraregistro'] = $ahora;
		$data['user_idregistro'] = $_SESSION['user']['id'];
	}
	$data['fechayhoraultima'] = $ahora;
	$data['user_idultima'] = $_SESSION['user']['id'];

	return $data;
}
/**
 * Prepara los datos para insertar o actualizar una pregunta en idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param int $id
 * @return array
 */
function faq_prepararDatosIdioma($idiomas, $idioma_id, $id=0)
{
	$data = SWPHP::_PrepararDatosIdioma($idiomas, $idioma_id, array('pregunta','respuesta','tags'), array('respuesta'));

	if($id)
	{
		$data['faq_id'] = $id;
	}
	$data['idioma_id'] = $idioma_id;

	return $data;
}
