<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-06-11
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/idiomas/admin/index.php
 *
 */

include_once(SWPHP_COMMON_DIR.'functions/images.php');

$id = isset($_GET["id"]) ? intval($_GET["id"]) : 0;
$op = isset($_GET['op']) ? $_GET['op'] : '';

$dirimg = 'img/lang/';
$sizeimg = array(16, 11);

$mostrarprincipal = true;

switch($op)
{
	case "edit":
		$registro = $db->GetRow("SELECT id,nombre,codigoiso,codigolang,peso FROM ".SWPHP_DBPREFIX."idiomas WHERE id = '{$id}'");
		$smarty->assign("registro", $registro);
	case "new":
		$admin_template = "{$swphp_module_templates_dir}admin/idioma.tpl";
		$mostrarprincipal = false;
		break;
	case "upd":
		if(idiomas_validarDatos($_POST))
		{
			$data = idiomas_prepararDatos($_POST, $id);

			$codigoiso_anterior = $db->GetValue('codigoiso', SWPHP_DBPREFIX.'idiomas', "WHERE id = '{$id}'", true, false);

			if(SWPHP::_ExecuteQuery(
				buildQuery_Update($data, SWPHP_DBPREFIX."idiomas", $id),
				"Idioma actualizado correctamente",
				"No se ha podido actualizar el registro"
			))
			{
				$fileimg = SWPHP::_SubirArchivo("imagen", $dirimg, "jpg", false, $data['codigoiso'].'.jpg');
				if($fileimg)
				{
					resizeImage($dirimg.$fileimg, $sizeimg, $dirimg);
				}

				$antiguo = $dirimg.$codigoiso_anterior.'.jpg';

				if($codigoiso_anterior && $codigoiso_anterior != $data['codigoiso'] && is_file($antiguo))
				{
					if($fileimg)
					{
						@unlink($antiguo);
					}
					else
					{
						rename($antiguo, $dirimg.$data['codigoiso'].'.jpg');
					}
				}
			}
		}
		break;
	case "reg":
		if(idiomas_validarDatos($_POST))
		{
			$data = idiomas_prepararDatos($_POST);

			if(SWPHP::_ExecuteQuery(
				buildQuery_Insert($data, SWPHP_DBPREFIX."idiomas"),
				"Idioma registrado correctamente",
				"No se ha podido insertar el registro"
			))
			{
				$fileimg = SWPHP::_SubirArchivo("imagen", $dirimg, "jpg", false, $data['codigoiso'].'.jpg');
				if($fileimg)
				{
					resizeImage($dirimg.$fileimg, $sizeimg, $dirimg);
				}
			}
		}
		break;
}

if($mostrarprincipal)
{
	$paginador = SWPHP::_CrearPaginador('idiomas');
	$paginador->SetParam('etiqueta', 'idioma');
	$paginador->Fill("SELECT i.id, '' AS flag, i.nombre, i.codigoiso, i.codigolang, i.activo FROM ".SWPHP_DBPREFIX."idiomas AS i ORDER BY i.peso ASC, i.id ASC");

	$paginador->SetParam('campos', array(
		'id'=>array("label"=>"Id.", "class"=>"numeric"),
		'flag'=>array("label"=>"", "orderby"=>false),
		'nombre'=>array("label"=>"Nombre"),
		'codigoiso'=>array("label"=>"Código ISO", "class"=>"center"),
		'codigolang'=>array("label"=>"Localización", "class"=>"center"),
		'activo'=>array("label"=>"", "orderby"=>false)
		));

	$paginador->SetParam('buscador', array(
		'i.nombre'=>'Nombre',
		'i.codigoiso'=>'Código ISO',
		'i.codigolang'=>'Localización',
		'i.id'=>'Id.',
		));

	function applyToReg(&$reg, $key)
	{
		global $swphp_mod_clave;

		$id = $reg['id'];

		$reg['flag'] = SWPHP::_LangFlag($reg['codigoiso']);

		$reg["activo"] = "<a href=\"".SWPHP_ADMIN_DIR.$swphp_mod_clave."/?op=edit&amp;id={$id}\">".SWPHP::_Icon("edit.png", 16, array("alt"=>"Editar", "title"=>"Editar Id. {$id}"))."</a>"
			.($reg["activo"] ?
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Desactivar\">".SWPHP::_Icon("green_button.png", 16, array("alt"=>"Desactivar"))."</a>"
				:
				" <a id=\"aActivar{$id}\" href=\"javascript:;\" onclick=\"xajax_Activar({$id})\" title=\"Activar\">".SWPHP::_Icon("red_button.png", 16, array("alt"=>"Activar"))."</a>")
			." <a id=\"aEliminar{$id}\" href=\"javascript:EliminarIdioma({$id})\" title=\"Eliminar\">".SWPHP::_Icon("remove.png", 16, array("alt"=>"Eliminar"))."</a>";
	}
	$paginador->SetParam('applyToRegs', 'applyToReg');

	$admin_template = "{$swphp_module_templates_dir}admin/idiomas.tpl";

	$smarty->assign('paginador', $paginador);
}
?>