<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-12-25
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/idiomas/install.php
 *
 */

/**
 * Realiza las actuaciones particulares de la instalación de este módulo:
 *
 * @param array $info
 * @return bool
 */
function idiomas_instalar($info)
{
	global $db;

	$ok = true;

	$ahora = date('Y-m-d H:i:s');

	SWPHP::_ExecuteQuery("SET NAMES 'utf8'", "", "");

	$queries = array(
		"CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX."idiomas` (
		  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
		  `nombre` varchar(60) NOT NULL,
		  `codigoiso` varchar(2) NOT NULL,
		  `codigolang` varchar(5) NOT NULL,
		  `fechayhoraregistro` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
		  `fechayhoraultima` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
		  `user_idregistro` tinyint(10) NOT NULL DEFAULT '0',
		  `user_idultima` tinyint(10) NOT NULL DEFAULT '0',
		  `activo` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `peso` smallint(5) NOT NULL,
		  PRIMARY KEY (`id`),
		  UNIQUE KEY `codigo` (`codigoiso`)
		) DEFAULT CHARSET=utf8",
		"INSERT INTO `".SWPHP_DBPREFIX."idiomas` VALUES(1, 'Español', 'es', 'es_ES', '{$ahora}', '{$ahora}', 1, 1, 1, 0)",
		"INSERT INTO `".SWPHP_DBPREFIX."idiomas` VALUES(2, 'English', 'en', 'en_EN', '{$ahora}', '{$ahora}', 1, 1, 0, 0)",
		"INSERT INTO `".SWPHP_DBPREFIX."idiomas` VALUES(3, 'Français', 'fr', 'fr_FR', '{$ahora}', '{$ahora}', 1, 1, 0, 0)",
		"INSERT INTO `".SWPHP_DBPREFIX."idiomas` VALUES(4, 'Deutsch', 'de', 'de_DE', '{$ahora}', '{$ahora}', 1, 1, 0, 0)",
		"INSERT INTO `".SWPHP_DBPREFIX."idiomas` VALUES(5, 'Italiano', 'it', 'it_IT', '{$ahora}', '{$ahora}', 1, 1, 0, 0)",
		"INSERT INTO `".SWPHP_DBPREFIX."idiomas` VALUES(6, 'Catalá', 'ca', 'ca_ES', '{$ahora}', '{$ahora}', 1, 1, 0, 0)",
		);
	foreach($queries as $query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo ejecutar la sentencia:<br /> {$query}");
	}

	$ok &= SWPHP::_CreateConfigValue('idioma', '1', 'idiomas', 'tag=select;options=SWPHP::_Rows2Assoc(SWPHP_DBPREFIX.\'idiomas\', \'nombre\', \'id\', \'WHERE activo = \'1\' ORDER BY peso\', array(\'0\', \'\'))', 'Idioma por defecto');

	return $ok;
}
/**
 * Realiza las actuaciones particulares de la desinstalación de este módulo
 *
 * @param array $info
 * @return bool
 */
function idiomas_desinstalar($info)
{
	//Es un módulo core

	return false;
}