<?php
/**
 * Armando Servillera Torres
 * www.pagina-web-barata.com
 * 2012-03-20
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/kapitaltruth/admin/categorias/admin/functions.inc.php
 *
 */

/**
 * Valida los datos de un registro de una categoría
 *
 * @param array $data
 * @return bool
 */
function kapitaltruth_categorias_validarDatos($data)
{
    global $swphp_idiomas;

	$ok = true;

	$requeridos = array(
		'texto'=>l('Nombre', 'kapitaltruth'),
		);

	foreach($requeridos as $key=>$nombre)
	{
		if(!isset($data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key]) || $data['idiomas'][SWPHP_IDIOMA_POR_DEFECTO][$key] == '')
		{
			SWPHP::_Msg(l('Falta el dato:', 'kapitaltruth')." {$nombre} ({$swphp_idiomas[SWPHP_IDIOMA_POR_DEFECTO]['nombre']})", "error");
			$ok = false;
		}
	}

	return $ok;
}
/**
 * Prepara los datos para insertar o actualizar una categoría en la base de datos
 *
 * @param array $data
 * @param int $id
 * @return array
 */
function kapitaltruth_categorias_prepararDatos($data, $id=0)
{
    if(empty($data['grupos']))
    {
        $data['grupos'] = array();
    }

	foreach($data as $key=>$value)
	{
		switch($key)
		{
			case 'activo':
            case 'porgrupos':
				$data[$key] = $value ? '1' : '0';
				break;
            case 'grupos':
                //Nada (pero no se descarta)
                break;
			default:
				//Cualquier otro dato lo descarto
				unset($data[$key]);
				break;
		}
	}

	return $data;
}
/**
 * Elimina una categoría
 *
 * @param int $id
 */
function kapitaltruth_categorias_eliminarCategoria($id)
{
	global $db;

	if($db->Execute("DELETE FROM ".SWPHP_DBPREFIX."kptl_categorias WHERE id = '{$id}'"))
	{
        $db->Execute("DELETE FROM ".SWPHP_DBPREFIX."kptl_categorias_idiomas WHERE categoria_id = '{$id}'");

		return true;
	}

	return false;
}
/**
 * Prepara los datos para insertar o actualizar datos de una categoría en idioma
 *
 * @param array $idiomas
 * @param int $idioma_id
 * @param int $id
 * @return array
 */
function kapitaltruth_categorias_prepararDatosIdioma($idiomas, $idioma_id, $id=0)
{
	$data = SWPHP::_PrepararDatosIdioma($idiomas, $idioma_id, array('texto'));

	if($id)
	{
		$data['categoria_id'] = $id;
	}
	$data['idioma_id'] = $idioma_id;

	return $data;
}
