<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-04-21
 * para Francisco Ortega
 *
 */
class KPTL_Movimiento extends SWPHP_Reg
{
    /**
     * Constructor
     *
     * @param int $id
     */
	public function __construct($id=null)
    {
        parent::__construct(SWPHP_DBPREFIX.'kptl_movimientos', $id);
    }
	/**
	 * Registra un movimiento de puntos de un usuario
	 *
	 * @param int $kptl_user_id
	 * @param int $tipo_id
	 * @param int $puntos
	 * @param string $info
	 * @param string $ref
	 * @return bool
	 */
    public function Registrar($kptl_user_id, $tipo_id, $puntos, $info, $ref="")
    {
   		if($this->_db->Exists($kptl_user_id, 'user_id', SWPHP_DBPREFIX.'kptl_movimientos'))
    	{
    		$saldo = $this->_db->GetValueQuery("SELECT saldo FROM ".SWPHP_DBPREFIX."kptl_movimientos WHERE user_id = '{$kptl_user_id}' ORDER BY fechayhora DESC LIMIT 1", false);
    		$saldo = intval($saldo);
    	}
    	else
   		{
   			$saldo = $this->_db->GetValueQuery("SELECT points_show FROM ".SWPHP_DBPREFIX."kptl_usuarios WHERE id = '{$kptl_user_id}'", false);
			$saldo = intval($saldo) - $puntos;
			if($saldo < 0)
			{
				$saldo = 0;
			}

   			$this->_id = null;

   			$this->SetData(array(
   				'user_id'=>$kptl_user_id,
   				'tipo_id'=>KPTL_TiposMovimiento::INICIALIZACION,
   				'puntos'=>$saldo,
   				'saldo'=>$saldo,
   				'fechayhora'=>date('Y-m-d H:i:s'),
   				'info'=>l('Inicialización', 'kapitaltruth'),
   				'ref'=>'',
   				));

   			$this->Save();
   		}

   		$this->_id = null;

   		return $this->SetData(array(
				'user_id'=>$kptl_user_id,
				'tipo_id'=>$tipo_id,
				'puntos'=>$puntos,
				'saldo'=>$saldo+$puntos,
				'fechayhora'=>date('Y-m-d H:i:s'),
				'info'=>$info,
				'ref'=>$ref,
			)) && $this->Save();
    }
}
?>