<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2012-05-07
 * para Francisco Ortega
 *
 */
class KPTL_Transferencia extends SWPHP_Reg
{
    /**
     * Constructor
     *
     * @param int $id
     */
	public function __construct($id=null)
    {
        parent::__construct(SWPHP_DBPREFIX.'kptl_transferencias', $id);
    }

    public function Hacer($user_from, $user_to, $puntos, $concepto, $fechayhora=null)
    {
    	if($puntos > 0)
    	{
    		$user_from_obj = new KPTL_User($user_from);
    		$user_to_obj = new KPTL_User($user_to);

    		if($user_from != $user_to && $user_from_obj->Exists() && $user_from_obj->GetValue('activo', false) && $user_to_obj->Exists() && $user_to_obj->GetValue('activo', false))
    		{
				$puntos_from = $user_from_obj->GetValue('puntos_show', false);

				unset($user_from_obj, $user_to_obj);

				if($puntos <= $puntos_from)
				{
					if(is_null($fechayhora))
			    	{
			    		$fechayhora = date('Y-m-d H:i:s');
			    	}

			    	$data = array(
			    		'user_from'=>$user_from,
			    		'user_to'=>$user_to,
			    		'puntos_from'=>$puntos_from,
			    		'puntos'=>$puntos,
			    		'fechayhora'=>$fechayhora,
			    		'concepto'=>$concepto,
			    		);

					if($this->SetData($data) && $this->Save())
					{
						$this->_db->Execute(sprintf("UPDATE ".SWPHP_DBPREFIX."kptl_usuarios SET puntos_show = puntos_show - %u, puntos_emitidos = puntos_emitidos + %u WHERE id = %u", $puntos, $puntos, $user_from));
						$this->_db->Execute(sprintf("UPDATE ".SWPHP_DBPREFIX."kptl_usuarios SET puntos_show = puntos_show + %u, puntos_recibidos = puntos_recibidos + %u WHERE id = %u", $puntos, $puntos, $user_to));

						$movimiento = new KPTL_Movimiento();
						$movimiento->Registrar($user_from, KPTL_TiposMovimiento::TRANSFERENCIAEMITIDA, -$puntos, l('Transferencia para', 'kapitaltruth').' '.KPTL_User::Id2NickNombre($user_to, false), $this->_id);
						$movimiento->Registrar($user_to, KPTL_TiposMovimiento::TRANSFERENCIARECIBIDA, $puntos, l('Transferencia de', 'kapitaltruth').' '.KPTL_User::Id2NickNombre($user_from, false), $this->_id);

						return true;
					}
					else
					{
						SWPHP::_Msg(l('No se pudo registrar la transferencia', 'kapitaltruth'), 'error');
					}
				}
				else
				{
					SWPHP::_Msg(l('[KPTL_Puntos] insuficientes', 'kapitaltruth'), 'error');
				}
    		}
    		else
    		{
    			SWPHP::_Msg(l('Usuario no válido', 'kapitaltruth'), 'error');
    		}
    	}
    	else
    	{
    		SWPHP::_Msg(l('[KPTL_Puntos] no válidos', 'kapitaltruth'), 'error');
    	}

    	return false;
    }
    /**
	 * Obtiene la consulta sql para coger transferencias
	 *
	 * @param mixed $ids
	 * @param string $campos
	 * @param string $filtro
	 * @return string
	 *
    public static function GetQuery($ids=null, $campos=null, $filtro='')
    {
    	if(is_null($campos))
    	{
    		$campos = "t.id, t.user_from, t.user_to, t.puntos_from, t.puntos, t.fechayhora, t.concepto";
    	}

    	if(is_null($ids))
    	{
    		$aux = '';
    	}
    	elseif(is_numeric($ids) && $ids > 0)
    	{
    		$aux = 'WHERE t.id = '.intval($ids);
    	}
    	elseif(is_array($ids))
    	{
    		$aux = 'WHERE';
    		$sep = ' ';
    		foreach($ids as $key=>$value)
    		{
				$aux .= sprintf("%s %s = '%s'", $sep, $key, addcslashes($value, "'"));
				$sep = ' AND';
    		}
    	}

    	$filtro = trim($filtro);
    	if($filtro)
    	{
    		if($aux)
    		{
    			if(strtoupper(substr($filtro, 0, 6)) == 'WHERE ')
    			{
    				$filtro = $aux.' AND ('.substr($filtro, 6).')';
    			}
    			else
    			{
    				$filtro = $aux.' '.$filtro;
    			}
    		}
    	}
    	else
    	{
    		$filtro = $aux;
    	}

    	return "SELECT {$campos} FROM ".SWPHP_DBPREFIX."kptl_transferencias AS t {$filtro}";
    }
    */
}
?>