<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2010-08-04
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/multimedia/index.php
 */

include_once(SWPHP_COMMON_DIR.'functions/images.php');

$cfg = SWPHP::_GetConfigValues("multimedia");

$itemsPerRow = isset($cfg["itemsPerRow"]) && $cfg["itemsPerRow"] ? $cfg["itemsPerRow"] : 4;
$thumbsWidth = (isset($cfg["thumbsWidth"]) && $cfg["thumbsWidth"] ? $cfg["thumbsWidth"] : '200');
$thumbsHeight = (isset($cfg["thumbsHeight"]) && $cfg["thumbsHeight"] ? $cfg["thumbsHeight"] : '150');
$thumbsWidth2 = (isset($cfg["thumbsWidth2"]) && $cfg["thumbsWidth2"] ? $cfg["thumbsWidth2"] : '200');
$thumbsHeight2 = (isset($cfg["thumbsHeight2"]) && $cfg["thumbsHeight2"] ? $cfg["thumbsHeight2"] : '130');
$mostrarNombres = isset($cfg["mostrarNombres"]) && $cfg["mostrarNombres"];
$cropNombres = isset($cfg["cropNombres"]) ? $cfg["cropNombres"] : '';
$dir = 'multimedia/';
$exts = array(
	"imagen"=>array('jpg','jpeg','gif','png','bmp'),
	"video"=>array('flv'),
	"audio"=>array('mp3'),
	);

/* INI
 Esto era del htaccess:

# Módulo multimedia
RewriteRule ^multimedia/(.*).(jpg|JPG|flv|mp3)$ multimedia/$1.$2 [L]
RewriteRule ^multimedia/(.*)/(imagen|video|audio)/?$ index.php?page0=multimedia&subdir=$1&ver=$2 [L]
RewriteRule ^multimedia/(imagen|video|audio)/?$ index.php?page0=multimedia&ver=$1 [L]
RewriteRule ^multimedia/(.*)/?$ index.php?page0=multimedia&subdir=$1 [L]

Ahora vamos a hacer eso desde php
*/
$request = urldecode($_SERVER['REQUEST_URI']);

if(substr($request,0,1) == '/')
{
	$request = substr($request, 1);
}

$len = strlen(SWPHP_PAGINA_ACTUAL);
if(substr($request,0,$len) == SWPHP_PAGINA_ACTUAL)
{
	$request = substr($request, $len);
}

$aux = quitarBarra($request);
$pos = strrpos($aux, '/');
if($pos === false)
{
	$pos = 0;
}
else
{
	$pos++;
}
$aux1 = substr($aux, 0, $pos);
$aux2 = substr($aux, $pos);
if(in_array($aux2, array('imagen', 'video', 'audio')))
{
	$_GET['subdir'] = $aux1;
	$_GET['ver'] = $aux2;
}
else
{
	$_GET['subdir'] = $request;
}
/* FIN */

if(isset($_GET['subdir']))
{
	$subdir = str_replace('.', '', $_GET['subdir']);
	if(is_dir($dir.$subdir))
	{
		$dir .= $subdir;
		//$description .= ", ".str_replace('/', ', ', $subdir);
		//$keywords .= ", ".str_replace(array(' ','/'), ', ', $subdir);
	}
}

if($dir[strlen($dir)-1] != '/')
{
	$dir .= '/';
}

$thumbsdir = $dir.'thumbs/';
SWPHP::_CheckDirWritable($thumbsdir);

$subdirs = explode('/', $dir);
$ruta = '';
$sep = '';
$localizador = '';
foreach($subdirs as $subdir)
{
	if($subdir)
	{
		$ruta .= $subdir.'/';
		if($ruta != 'multimedia/')
		{
			$localizador .= sprintf("%s<a href=\"%s\">%s</a>", $sep, multimedia_ruta2paginaActual($ruta), $subdir);
			$sep = ' &rsaquo; ';
		}
	}
}

$imagen = getFilesExt($dir, $exts['imagen']);
$video = getFilesExt($dir, $exts['video']);
$audio = getFilesExt($dir, $exts['audio']);

$hayImagenes = sizeof($imagen) > 0;
$hayVideos = sizeof($video) > 0;
$hayAudios = sizeof($audio) > 0;

$extralinks = array();

$dirUrl = multimedia_ruta2paginaActual($dir);

$ver = isset($_GET['ver']) ? $_GET['ver'] : '';
switch($ver)
{
	case 'imagen':
		$localizador .= sprintf("%sImagen", $sep);

		if($hayVideos)
		{
			$extralinks[] = array("Video", "{$dirUrl}video/");
		}
		if($hayAudios)
		{
			$extralinks[] = array("Audio", "{$dirUrl}audio/");
		}

		$files = $imagen;
		sort($files);

		$thumbs = array();
        $names = array();
		foreach($files as $file)
		{
			$thumbs[] = multimedia_getThumb($dir, $file);
            $name = getName($file);
            $names[] = trim($cropNombres && ($pos = strpos($name, $cropNombres)) !== false ? substr($name, $pos+1) : $name);
		}

		$smarty->assign("files", $files);
		$smarty->assign("thumbs", $thumbs);
        $smarty->assign("names", $names);

		$subtemplate = "multimedia_imagen.tpl";
		break;
	case 'video':
		$localizador .= sprintf("%sVideo", $sep);

		if($hayImagenes)
		{
			$extralinks[] = array("Imagen", "{$dirUrl}imagen/");
		}
		if($hayAudios)
		{
			$extralinks[] = array("Audio", "{$dirUrl}audio/");
		}

		$files = $video;
		sort($files);

		$filesexts = array();
		$urls = array();
		$thumbs = array();
		$names = array();
        foreach($files as $file)
		{
			$filesexts[] = getExtension($file, false);
			$urls[] = addcslashes(substr($file, 0, strrpos($file, ".")), "'");
			$thumbs[] = multimedia_getThumb($dir, $file);
            $name = getName($file);
            $names[] = trim($cropNombres && ($pos = strpos($name, $cropNombres)) !== false ? substr($name, $pos+1) : $name);
		}

		$smarty->assign("files", $files);
		$smarty->assign("filesexts", $filesexts);
		$smarty->assign("urls", $urls);
		$smarty->assign("thumbs", $thumbs);
        $smarty->assign("names", $names);

		$subtemplate = "multimedia_video.tpl";
		break;
	case 'audio':
		$localizador .= sprintf("%sAudio", $sep);

		if($hayImagenes)
		{
			$extralinks[] = array("Imagen", "{$dirUrl}imagen/");
		}
		if($hayVideos)
		{
			$extralinks[] = array("Video", "{$dirUrl}video/");
		}

		$files = $audio;
		sort($files);

		$strUrls = '';
		$strTitulos = '';
		foreach($files as $file)
		{
			if($strUrls != '')
			{
				$strUrls .= '|';
				$strTitulos .= '|';
			}
			$strUrls .= "{$dir}/{$file}";
			$strTitulos .= getName($file);
		}

        $smarty->assign("numFiles", sizeof($files));
        $smarty->assign("strUrls", $strUrls);
        $smarty->assign("strTitulos", $strTitulos);

        $subtemplate = "multimedia_audio.tpl";
		break;
	default:
		//Subdirectorios
		$subdirs = getDirs($dir);
		sort($subdirs);

		//Imagen
		$imagen = $hayImagenes ? sprintf("<td>
				<a href=\"%simagen/\" title=\"Imagen\"><img src=\"".SWPHP_THEME_DIR."img/multimedia/imagen.png\" alt=\"Imagen\" /></a><br />Imagen
			</td>", $dirUrl) : '';

		//Video
		$video = $hayVideos ? sprintf("<td>
				<a href=\"%svideo/\" title=\"Video\"><img src=\"".SWPHP_THEME_DIR."img/multimedia/video.png\" alt=\"Video\" /></a><br />Video
			</td>", $dirUrl) : '';

		//Audio
		$audio = $hayAudios ? sprintf("<td>
				<a href=\"%saudio/\" title=\"audio\"><img src=\"".SWPHP_THEME_DIR."img/multimedia/audio.png\" alt=\"Audio\" /></a><br />Audio
			</td>", $dirUrl) : '';

		if($imagen || $video)// || $audio)
		{
			SWPHP::_MkDir($dir.'thumbs');
		}

		$smarty->assign("subdirs", $subdirs);

		$smarty->assign("imagen", $imagen);
		$smarty->assign("video", $video);
		$smarty->assign("audio", $audio);

		$subtemplate = "multimedia_default.tpl";
		break;
}

if(is_numeric($thumbsWidth))
{
	$thumbsWidth .= "px";
}
if(is_numeric($thumbsHeight))
{
	$thumbsHeight .= "px";
}
if(is_numeric($thumbsWidth2))
{
	$thumbsWidth2 .= "px";
}
if(is_numeric($thumbsHeight2))
{
	$thumbsHeight2 .= "px";
}

$smarty->assign("dir", $dir);
$smarty->assign("dirUrl", $dirUrl);

$smarty->assign('localizador', $localizador);
$smarty->assign("extralinks", $extralinks);

$smarty->assign('itemsPerRow', $itemsPerRow);
$smarty->assign('thumbsWidth', $thumbsWidth);
$smarty->assign('thumbsHeight', $thumbsHeight);
$smarty->assign('thumbsWidth2', $thumbsWidth2);
$smarty->assign('thumbsHeight2', $thumbsHeight2);

$smarty->assign('mostrarNombres', isset($cfg["mostrarNombres"]) && $cfg["mostrarNombres"]);
$smarty->assign('cropNombres', isset($cfg["cropNombres"]) && $cfg["cropNombres"]);

$smarty->assign('swphp_templatecontenido', "{$swphp_module_templates_dir}multimedia.tpl");
$smarty->assign('subtemplate', $swphp_module_templates_dir.$subtemplate);
?>