<?php
/**
 * Jose Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-03-15
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/noticias/index.php
 */

$config = SWPHP::_GetConfigValues('noticias');

$fuente = empty($_GET['f']) ? false : $_GET['f'];
$friendly = isset($_GET['page1']) ? trim($_GET['page1']) : false;

$mostrarlistado = true;

if($friendly && !is_numeric($friendly))
{
	if($db->Exists($friendly, 'friendly', SWPHP_DBPREFIX.'fuentesnoticias'))
	{
		$fuente = $friendly;
		$friendly = isset($_GET['page2']) ? trim($_GET['page2']) : false;
	}

	if($friendly && !is_numeric($friendly))
	{
		$mostrarlistado = false;

		$filtrosIdioma = array(
			"ni.idioma_id = '{$_SESSION['SWPHP_IDIOMA_ACTUAL']}'",
			"ni.idioma_id = '".SWPHP_IDIOMA_POR_DEFECTO."'",
			"ni.idioma_id IN('".implode("','", array_keys($swphp_idiomas))."')",
			);

		foreach($filtrosIdioma as $filtroIdioma)
		{
			$row = $db->GetRow(sprintf("SELECT n.id, ni.titulo, ni.introduccion, ni.contenido, n.fecha, ni.keywords, n.imagen, ni.urlimagen, n.mostrarimagen, n.imagenampliable, n.visitas, f.nombre AS fuente, n.url_fuente, n.mostrarfuente, ni.idioma_id, n.activo"
				." FROM ".SWPHP_DBPREFIX."noticias AS n"
				." JOIN ".SWPHP_DBPREFIX."noticias_idiomas AS ni ON n.id = ni.noticia_id AND {$filtroIdioma}"
				." LEFT JOIN ".SWPHP_DBPREFIX."fuentesnoticias AS f ON f.id = n.fuente_id"
				." WHERE ni.friendly = '%s'", addcslashes($friendly,"'")));
			if($row)
			{
				break;
			}
		}

		if(isset($row) && $row)
		{
			if($config['tituloPagina'])
			{
				$swphp_pagina->SetValue('titulo', $row['titulo']);
			}
			$swphp_pagina->SetValue('title', $row['titulo']);
			$swphp_pagina->SetValue('descripcion', SWPHP::_Str2MetaDescription($row['introduccion'], true));
			$swphp_pagina->SetValue('keywords', $row['keywords']);
			$swphp_pagina->SetCanonical(SWPHP_PAGINA_ACTUAL.$friendly.'/');

            SWPHP::_AddExtrahead(sprintf('<meta property="og:title" content="%s" />
<meta property="og:type" content="article" />', $row['titulo']));

			if($row['activo'])
			{
				$row['contenido'] = SWPHP::_ProcesarContenido($row['contenido']);
				$row = noticias_asignarImagenes($row);

				if(is_file($row['imagen']))
				{
					SWPHP::_AddExtrahead('<meta property="og:image" content="'.$swphp_config['url'].$row['imagen'].'"/>');
				}

				$smarty->assign('swphp_noticia', $row);
				$smarty->assign('swphp_templatecontenido', SWPHP::_GetModuleTemplate('noticia.tpl'));

				$smarty->assign('swphp_noticianext', $db->GetRow("SELECT ni.titulo, ni.friendly FROM ".SWPHP_DBPREFIX."noticias AS n JOIN ".SWPHP_DBPREFIX."noticias_idiomas AS ni ON n.id = ni.noticia_id AND ni.idioma_id = '{$row['idioma_id']}' WHERE n.activo = 1 AND (n.fecha > '{$row['fecha']}' OR (n.fecha = '{$row['fecha']}' AND n.id > '{$row['id']}')) ORDER BY n.fecha ASC, n.id ASC"));
				$smarty->assign('swphp_noticiaprev', $db->GetRow("SELECT ni.titulo, ni.friendly FROM ".SWPHP_DBPREFIX."noticias AS n JOIN ".SWPHP_DBPREFIX."noticias_idiomas AS ni ON n.id = ni.noticia_id AND ni.idioma_id = '{$row['idioma_id']}' WHERE n.activo = 1 AND (n.fecha < '{$row['fecha']}' OR (n.fecha = '{$row['fecha']}' AND n.id < '{$row['id']}')) ORDER BY n.fecha DESC, n.id DESC"));

				$db->Execute("UPDATE ".SWPHP_DBPREFIX."noticias SET visitas = visitas + 1 WHERE id = '{$row['id']}'");
			}
			else
			{
				$swphp_pagina->SetValue('contenido', '<h1>'.$row['titulo'].'</h1><p>Este contenido no está disponible</p>');
				$swphp_pagina->SetValue('icono', 'warning.png');
				$swphp_pagina->SetValue('robots', 'noindex, follow');
			}
		}
		else
		{
			$swphp_pagina->NotFound();
		}
	}
}

$noticias_url = SWPHP_PAGINA_ACTUAL.($fuente ? ponerBarra($fuente) : '');

if($mostrarlistado)
{
	require(SWPHP_COMMON_DIR.'classes/LinksPaginacion.class.php');

	$filtroFuente = $fuente ? " AND f.friendly = '".addcslashes($fuente, "'")."'" : "";

	$total = $db->GetValueQuery("SELECT COUNT(n.id)"
		." FROM ".SWPHP_DBPREFIX."noticias AS n"
		." JOIN ".SWPHP_DBPREFIX."noticias_idiomas AS ni ON n.id = ni.noticia_id AND ni.idioma_id = '{$_SESSION['SWPHP_IDIOMA_ACTUAL']}'"
		." LEFT JOIN ".SWPHP_DBPREFIX."fuentesnoticias AS f ON n.fuente_id = f.id"
		." WHERE n.activo = 1".$filtroFuente, false);
	$rpp = isset($config["rpp"]) ? intval($config["rpp"]) : 10;
	$numpags = ceil($total / $rpp);
	$pag = intval($friendly);
	if($pag > $numpags) $pag = $numpags;
	if($pag < 1) $pag = 1;
	$limit = sprintf("LIMIT %s, %s", ($pag-1)*$rpp, $rpp);

	$_SESSION['noticias']['pag'] = $pag;

	$_SERVER['REQUEST_URI'] = '/'.$noticias_url.$pag.'/'; //Para canonical

	$noticias = $db->GetRows("SELECT n.id, ni.friendly, n.fecha, ni.titulo, ni.introduccion, n.imagen, f.nombre AS fuente"
		." FROM ".SWPHP_DBPREFIX."noticias AS n"
		." JOIN ".SWPHP_DBPREFIX."noticias_idiomas AS ni ON n.id = ni.noticia_id AND ni.idioma_id = '{$_SESSION['SWPHP_IDIOMA_ACTUAL']}'"
		." LEFT JOIN ".SWPHP_DBPREFIX."fuentesnoticias AS f ON n.fuente_id = f.id"
		." WHERE n.activo = 1".$filtroFuente
		." ORDER BY n.fecha DESC, n.id DESC {$limit}");

	foreach($noticias as $key=>$noticia)
	{
		$noticias[$key] = noticias_asignarImagenes($noticia);
	}

	$smarty->assign('swphp_fuentesnoticias', $db->GetArrayForHTMLSelect('friendly', 'nombre', SWPHP_DBPREFIX.'fuentesnoticias', '', array('', l('[TODAS]', 'noticias'))));
	$smarty->assign('swphp_noticias', $noticias);
	$smarty->assign('swphp_templatecontenido', SWPHP::_GetModuleTemplate('noticias.tpl'));

	if(!empty($_REQUEST['nude']) && !empty($_REQUEST['hash']) && $_REQUEST['hash'] == SWPHP::_Encrypt($_REQUEST['nude']))
	{
		$smarty->assign('swphp_noticias_nude', true);
		$swphp_main_template = SWPHP::_GetModuleTemplate('noticias.tpl');
	}
	else
	{
		$smarty->assign('swphp_noticias_nude', false);
		$smarty->assign('swphp_noticiaspaginacion', LinksPaginacion::getLinksPaginacion($noticias_url, $pag, $numpags, $total));
		if($pag > 1)
		{
			$swphp_pagina->Append('title', "(página {$pag})");
			$swphp_pagina->Append('descripcion', "Página {$pag} de resultados.");
			$swphp_pagina->Append('keywords', ", pagina, {$pag}");
		}
	}
}

$smarty->assign('swphp_fuenteseleccionada', $fuente);
$smarty->assign('swphp_noticiascfg', $config);
$smarty->assign('noticias_url', $noticias_url);
