<?php
/**
 * José Carlos Cruz Parra
 * programadorphpfreelance.com
 * 2011-12-25
 *
 * SIMPLE WEB PHP EDICION ADMINISTRADA
 *
 * inc/modulos/noticias/install.php
 *
 */

/**
 * Realiza las actuaciones particulares de la instalación de este módulo:
 *
 * @param array $info
 * @return bool
 */
function noticias_instalar($info)
{
	$ok = true;

	SWPHP::_ExecuteQuery("SET NAMES 'utf8'", "", "");

	$queries = array(
		"CREATE TABLE IF NOT EXISTS `".SWPHP_DBPREFIX."noticias` (
		  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
		  `titulo` varchar(120) NOT NULL DEFAULT '',
		  `introduccion` varchar(255) NOT NULL,
		  `contenido` text NOT NULL,
		  `friendly` varchar(120) NOT NULL DEFAULT '',
		  `keywords` varchar(255) NOT NULL DEFAULT '',
		  `tags` varchar(255) NOT NULL DEFAULT '',
		  `fecha` date NOT NULL,
		  `fechayhoraregistro` datetime NOT NULL,
		  `fechayhoraultima` datetime NOT NULL,
		  `user_idregistro` int(10) unsigned NOT NULL,
		  `user_idultima` int(10) unsigned NOT NULL,
		  `activo` tinyint(1) unsigned NOT NULL DEFAULT '1',
		  `imagen` varchar(255) NOT NULL,
		  `mostrarimagen` tinyint(1) NOT NULL DEFAULT '1',
		  `imagenampliable` tinyint(1) NOT NULL DEFAULT '1',
		  PRIMARY KEY (`id`)
		) DEFAULT CHARSET=utf8",
		);
	foreach($queries as $query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo ejecutar la sentencia:<br /> {$query}");
	}

	$ok &= SWPHP::_CreateConfigValue('thumbsize', '158', 'noticias', 'tag=input;type=text;size=5;maxlength=5', 'Tamaño de las imágenes en miniatura');
	$ok &= SWPHP::_CreateConfigValue('imagesize', '300', 'noticias', 'tag=input;type=text;size=5;maxlength=5', 'Tamaño de las imágenes en la noticia');
	$ok &= SWPHP::_CreateConfigValue('largesize', '800', 'noticias', 'tag=input;type=text;size=5;maxlength=5', 'Tamaño de las imágenes al ampliar');
	$ok &= SWPHP::_CreateConfigValue('dateformat', '%d/%m/%Y', 'noticias', 'tag=input;type=text;size=20;maxlength=40', 'Formato de fecha (al estilo Smarty)');
	$ok &= SWPHP::_CreateConfigValue('truncatetitulo', '80', 'noticias', 'tag=input;type=text;size=50;maxlength=10', 'Caracteres máximos en los listados para el título');
	$ok &= SWPHP::_CreateConfigValue('truncateintro', '255', 'noticias', 'tag=input;type=text;size=50;maxlength=10', 'Caracteres máximos en los listados para la introducción');

	return $ok;
}
/**
 * Realiza las actuaciones particulares de la desinstalación de este módulo
 *
 * @param array $info
 * @return bool
 */
function noticias_desinstalar($info)
{
	$ok = true;

	$queries = array(
		"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."noticias",
		"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."fuentesnoticias",
		"DROP TABLE IF EXISTS ".SWPHP_DBPREFIX."noticias_idiomas",
		);
	foreach($queries as $query)
	{
		$ok &= SWPHP::_ExecuteQuery($query, "", "No se pudo ejecutar la sentencia:<br /> {$query}");
	}

	$ok &= SWPHP::_DeleteAllConfigValues('noticias');

	return $ok;
}